blob: 47ac830dc94c850cc18c39251b48e17d4351a7de [file] [log] [blame]
Jason Kusumabe998f42015-09-03 15:53:13 -07001#!/bin/bash
2
Amin Hassani13520932017-07-26 11:26:05 -07003#
4# Copyright (C) 2015 The Android Open Source Project
5#
6# Licensed under the Apache License, Version 2.0 (the "License");
7# you may not use this file except in compliance with the License.
8# You may obtain a copy of the License at
9#
10# http://www.apache.org/licenses/LICENSE-2.0
11#
12# Unless required by applicable law or agreed to in writing, software
13# distributed under the License is distributed on an "AS IS" BASIS,
14# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15# See the License for the specific language governing permissions and
16# limitations under the License.
17#
Jason Kusumabe998f42015-09-03 15:53:13 -070018
19# Script to generate a Brillo update for use by the update engine.
20#
21# usage: brillo_update_payload COMMAND [ARGS]
22# The following commands are supported:
23# generate generate an unsigned payload
24# hash generate a payload or metadata hash
25# sign generate a signed payload
Alex Deymo98e691c2016-02-04 21:05:45 -080026# properties generate a properties file from a payload
Amin Hassani13520932017-07-26 11:26:05 -070027# verify verify a payload by recreating a target image.
Tudor Brindusb432db82018-06-29 13:13:27 -070028# check verify a payload using paycheck (static testing)
Jason Kusumabe998f42015-09-03 15:53:13 -070029#
30# Generate command arguments:
Jason Kusuma9a4cae22015-10-08 18:17:57 -070031# --payload generated unsigned payload output file
32# --source_image if defined, generate a delta payload from the specified
33# image to the target_image
34# --target_image the target image that should be sent to clients
Amin Hassani13520932017-07-26 11:26:05 -070035# --metadata_size_file if defined, generate a file containing the size of the
36# payload metadata in bytes to the specified file
Jason Kusumabe998f42015-09-03 15:53:13 -070037#
38# Hash command arguments:
39# --unsigned_payload the input unsigned payload to generate the hash from
40# --signature_size signature sizes in bytes in the following format:
Alex Deymo89ff9e32015-09-15 19:29:01 -070041# "size1:size2[:...]"
Jason Kusumabe998f42015-09-03 15:53:13 -070042# --payload_hash_file if defined, generate a payload hash and output to the
43# specified file
44# --metadata_hash_file if defined, generate a metadata hash and output to the
45# specified file
46#
47# Sign command arguments:
Alex Deymo89ff9e32015-09-15 19:29:01 -070048# --unsigned_payload the input unsigned payload to insert the signatures
49# --payload the output signed payload
50# --signature_size signature sizes in bytes in the following format:
51# "size1:size2[:...]"
52# --payload_signature_file the payload signature files in the following
53# format:
54# "payload_signature1:payload_signature2[:...]"
55# --metadata_signature_file the metadata signature files in the following
56# format:
57# "metadata_signature1:metadata_signature2[:...]"
Jason Kusuma9a4cae22015-10-08 18:17:57 -070058# --metadata_size_file if defined, generate a file containing the size of
59# the signed payload metadata in bytes to the
60# specified file
Jason Kusumabe998f42015-09-03 15:53:13 -070061# Note that the number of signature sizes and payload signatures have to match.
Alex Deymo98e691c2016-02-04 21:05:45 -080062#
63# Properties command arguments:
64# --payload the input signed or unsigned payload
65# --properties_file the output path where to write the properties, or
66# '-' for stdout.
Amin Hassani13520932017-07-26 11:26:05 -070067# Verify command arguments:
68# --payload payload input file
69# --source_image verify payload to the specified source image.
70# --target_image the target image to verify upon.
Tudor Brindusb432db82018-06-29 13:13:27 -070071#
72# Check command arguments:
73# Symmetrical with the verify command.
Alex Deymo98e691c2016-02-04 21:05:45 -080074
Jason Kusumabe998f42015-09-03 15:53:13 -070075
Alex Deymo61e1fa82016-01-19 15:16:34 -080076# Exit codes:
77EX_UNSUPPORTED_DELTA=100
78
Jason Kusumaf514c542015-11-05 18:43:45 -080079warn() {
80 echo "brillo_update_payload: warning: $*" >&2
81}
82
Gilad Arnold957ce122015-10-14 16:02:55 -070083die() {
84 echo "brillo_update_payload: error: $*" >&2
85 exit 1
Jason Kusumabe998f42015-09-03 15:53:13 -070086}
87
Gilad Arnold957ce122015-10-14 16:02:55 -070088# Loads shflags. We first look at the default install location; then look for
Amin Hassani2a14d412018-05-31 13:01:09 -070089# crosutils (chroot); finally check our own directory.
Gilad Arnold957ce122015-10-14 16:02:55 -070090load_shflags() {
91 local my_dir="$(dirname "$(readlink -f "$0")")"
92 local path
93 for path in /usr/share/misc {/usr/lib/crosutils,"${my_dir}"}/lib/shflags; do
94 if [[ -r "${path}/shflags" ]]; then
95 . "${path}/shflags" || die "Could not load ${path}/shflags."
96 return
97 fi
98 done
99 die "Could not find shflags."
100}
101
102load_shflags
Jason Kusumabe998f42015-09-03 15:53:13 -0700103
Alex Deymoc64ffd52015-09-25 18:10:07 -0700104HELP_GENERATE="generate: Generate an unsigned update payload."
105HELP_HASH="hash: Generate the hashes of the unsigned payload and metadata used \
106for signing."
107HELP_SIGN="sign: Insert the signatures into the unsigned payload."
Alex Deymo98e691c2016-02-04 21:05:45 -0800108HELP_PROPERTIES="properties: Extract payload properties to a file."
Tudor Brindusb432db82018-06-29 13:13:27 -0700109HELP_VERIFY="verify: Verify a (signed) update payload using delta_generator."
110HELP_CHECK="check: Check a (signed) update payload using paycheck (static \
111testing)."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700112
113usage() {
114 echo "Supported commands:"
115 echo
116 echo "${HELP_GENERATE}"
117 echo "${HELP_HASH}"
118 echo "${HELP_SIGN}"
Alex Deymo98e691c2016-02-04 21:05:45 -0800119 echo "${HELP_PROPERTIES}"
Amin Hassani13520932017-07-26 11:26:05 -0700120 echo "${HELP_VERIFY}"
Tudor Brindusb432db82018-06-29 13:13:27 -0700121 echo "${HELP_CHECK}"
Alex Deymoc64ffd52015-09-25 18:10:07 -0700122 echo
123 echo "Use: \"$0 <command> --help\" for more options."
124}
125
126# Check that a command is specified.
Jason Kusumabe998f42015-09-03 15:53:13 -0700127if [[ $# -lt 1 ]]; then
Tudor Brindusb432db82018-06-29 13:13:27 -0700128 echo "Please specify a command [generate|hash|sign|properties|verify|check]"
Jason Kusumabe998f42015-09-03 15:53:13 -0700129 exit 1
130fi
131
Alex Deymoc64ffd52015-09-25 18:10:07 -0700132# Parse command.
133COMMAND="${1:-}"
134shift
135
136case "${COMMAND}" in
137 generate)
138 FLAGS_HELP="${HELP_GENERATE}"
139 ;;
140
141 hash)
142 FLAGS_HELP="${HELP_HASH}"
143 ;;
144
145 sign)
146 FLAGS_HELP="${HELP_SIGN}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700147 ;;
Alex Deymo98e691c2016-02-04 21:05:45 -0800148
149 properties)
150 FLAGS_HELP="${HELP_PROPERTIES}"
151 ;;
Amin Hassani13520932017-07-26 11:26:05 -0700152
153 verify)
154 FLAGS_HELP="${HELP_VERIFY}"
155 ;;
156
Tudor Brindusb432db82018-06-29 13:13:27 -0700157 check)
158 FLAGS_HELP="${HELP_CHECK}"
159 ;;
160
Jason Kusumabe998f42015-09-03 15:53:13 -0700161 *)
Alex Deymoc64ffd52015-09-25 18:10:07 -0700162 echo "Unrecognized command: \"${COMMAND}\"" >&2
163 usage >&2
Jason Kusumabe998f42015-09-03 15:53:13 -0700164 exit 1
165 ;;
166esac
167
Jason Kusumabe998f42015-09-03 15:53:13 -0700168# Flags
Alex Deymoc64ffd52015-09-25 18:10:07 -0700169FLAGS_HELP="Usage: $0 ${COMMAND} [flags]
170${FLAGS_HELP}"
171
172if [[ "${COMMAND}" == "generate" ]]; then
173 DEFINE_string payload "" \
174 "Path to output the generated unsigned payload file."
175 DEFINE_string target_image "" \
176 "Path to the target image that should be sent to clients."
177 DEFINE_string source_image "" \
178 "Optional: Path to a source image. If specified, this makes a delta update."
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700179 DEFINE_string metadata_size_file "" \
180 "Optional: Path to output metadata size."
Sen Jiang8e768e92017-06-28 17:13:19 -0700181 DEFINE_string max_timestamp "" \
182 "Optional: The maximum unix timestamp of the OS allowed to apply this \
183payload, should be set to a number higher than the build timestamp of the \
184system running on the device, 0 if not specified."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700185fi
186if [[ "${COMMAND}" == "hash" || "${COMMAND}" == "sign" ]]; then
187 DEFINE_string unsigned_payload "" "Path to the input unsigned payload."
188 DEFINE_string signature_size "" \
189 "Signature sizes in bytes in the following format: size1:size2[:...]"
190fi
191if [[ "${COMMAND}" == "hash" ]]; then
192 DEFINE_string metadata_hash_file "" \
193 "Optional: Path to output metadata hash file."
194 DEFINE_string payload_hash_file "" \
195 "Optional: Path to output payload hash file."
196fi
197if [[ "${COMMAND}" == "sign" ]]; then
198 DEFINE_string payload "" \
199 "Path to output the generated unsigned payload file."
200 DEFINE_string metadata_signature_file "" \
201 "The metatada signatures in the following format: \
202metadata_signature1:metadata_signature2[:...]"
203 DEFINE_string payload_signature_file "" \
204 "The payload signatures in the following format: \
205payload_signature1:payload_signature2[:...]"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700206 DEFINE_string metadata_size_file "" \
207 "Optional: Path to output metadata size."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700208fi
Alex Deymo98e691c2016-02-04 21:05:45 -0800209if [[ "${COMMAND}" == "properties" ]]; then
210 DEFINE_string payload "" \
211 "Path to the input signed or unsigned payload file."
212 DEFINE_string properties_file "-" \
213 "Path to output the extracted property files. If '-' is passed stdout will \
214be used."
215fi
Tudor Brindusb432db82018-06-29 13:13:27 -0700216if [[ "${COMMAND}" == "verify" || "${COMMAND}" == "check" ]]; then
Amin Hassani13520932017-07-26 11:26:05 -0700217 DEFINE_string payload "" \
218 "Path to the input payload file."
219 DEFINE_string target_image "" \
220 "Path to the target image to verify upon."
221 DEFINE_string source_image "" \
222 "Optional: Path to a source image. If specified, the delta update is \
223applied to this."
224fi
Alex Deymo98e691c2016-02-04 21:05:45 -0800225
Alex Deymo5fbb1102017-01-12 13:55:52 -0800226DEFINE_string work_dir "${TMPDIR:-/tmp}" "Where to dump temporary files."
Jason Kusumabe998f42015-09-03 15:53:13 -0700227
228# Parse command line flag arguments
229FLAGS "$@" || exit 1
230eval set -- "${FLAGS_ARGV}"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700231set -e
Jason Kusumabe998f42015-09-03 15:53:13 -0700232
Alex Deymo5fbb1102017-01-12 13:55:52 -0800233# Override the TMPDIR with the passed work_dir flags, which anyway defaults to
234# ${TMPDIR}.
235TMPDIR="${FLAGS_work_dir}"
236export TMPDIR
237
Alex Deymo89ff9e32015-09-15 19:29:01 -0700238# Associative arrays from partition name to file in the source and target
239# images. The size of the updated area must be the size of the file.
240declare -A SRC_PARTITIONS
241declare -A DST_PARTITIONS
242
Alex Deymo20bdc702016-12-07 21:07:11 -0800243# Associative arrays for the .map files associated with each src/dst partition
244# file in SRC_PARTITIONS and DST_PARTITIONS.
245declare -A SRC_PARTITIONS_MAP
246declare -A DST_PARTITIONS_MAP
247
Sen Jiang788c2d92016-03-09 12:48:40 -0800248# List of partition names in order.
249declare -a PARTITIONS_ORDER
250
Alex Deymo89ff9e32015-09-15 19:29:01 -0700251# A list of temporary files to remove during cleanup.
252CLEANUP_FILES=()
253
Alex Deymo48b502a2015-09-17 19:00:18 -0700254# Global options to force the version of the payload.
255FORCE_MAJOR_VERSION=""
256FORCE_MINOR_VERSION=""
257
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800258# Path to the postinstall config file in target image if exists.
259POSTINSTALL_CONFIG_FILE=""
260
Alex Deymoc97df432015-09-25 17:23:52 -0700261# read_option_int <file.txt> <option_key> [default_value]
262#
263# Reads the unsigned integer value associated with |option_key| in a key=value
264# file |file.txt|. Prints the read value if found and valid, otherwise prints
265# the |default_value|.
266read_option_uint() {
267 local file_txt="$1"
268 local option_key="$2"
269 local default_value="${3:-}"
270 local value
271 if value=$(look "${option_key}=" "${file_txt}" | tail -n 1); then
272 if value=$(echo "${value}" | cut -f 2- -d "=" | grep -E "^[0-9]+$"); then
273 echo "${value}"
274 return
275 fi
276 fi
277 echo "${default_value}"
278}
279
Sen Jiangd0e9a892016-07-22 16:28:07 -0700280# truncate_file <file_path> <file_size>
281#
Dan Willemsen32711862018-10-04 21:25:50 -0700282# Truncate the given |file_path| to |file_size| using python.
Sen Jiangd0e9a892016-07-22 16:28:07 -0700283# The truncate binary might not be available.
284truncate_file() {
285 local file_path="$1"
286 local file_size="$2"
Dan Willemsen32711862018-10-04 21:25:50 -0700287 python -c "open(\"${file_path}\", 'a').truncate(${file_size})"
Sen Jiangd0e9a892016-07-22 16:28:07 -0700288}
289
Alex Deymo89ff9e32015-09-15 19:29:01 -0700290# Create a temporary file in the work_dir with an optional pattern name.
291# Prints the name of the newly created file.
292create_tempfile() {
293 local pattern="${1:-tempfile.XXXXXX}"
294 mktemp --tmpdir="${FLAGS_work_dir}" "${pattern}"
295}
Jason Kusumabe998f42015-09-03 15:53:13 -0700296
297cleanup() {
298 local err=""
Alex Deymo89ff9e32015-09-15 19:29:01 -0700299 rm -f "${CLEANUP_FILES[@]}" || err=1
Jason Kusumabe998f42015-09-03 15:53:13 -0700300
301 # If we are cleaning up after an error, or if we got an error during
302 # cleanup (even if we eventually succeeded) return a non-zero exit
303 # code. This triggers additional logging in most environments that call
304 # this script.
305 if [[ -n "${err}" ]]; then
306 die "Cleanup encountered an error."
307 fi
308}
309
310cleanup_on_error() {
311 trap - INT TERM ERR EXIT
312 cleanup
313 die "Cleanup success after an error."
314}
315
316cleanup_on_exit() {
317 trap - INT TERM ERR EXIT
318 cleanup
319}
320
321trap cleanup_on_error INT TERM ERR
322trap cleanup_on_exit EXIT
323
Alex Deymo48b502a2015-09-17 19:00:18 -0700324
Sen Jiang788c2d92016-03-09 12:48:40 -0800325# extract_image <image> <partitions_array> [partitions_order]
Alex Deymo48b502a2015-09-17 19:00:18 -0700326#
327# Detect the format of the |image| file and extract its updatable partitions
328# into new temporary files. Add the list of partition names and its files to the
Sen Jiang788c2d92016-03-09 12:48:40 -0800329# associative array passed in |partitions_array|. If |partitions_order| is
330# passed, set it to list of partition names in order.
Alex Deymo48b502a2015-09-17 19:00:18 -0700331extract_image() {
332 local image="$1"
333
334 # Brillo images are zip files. We detect the 4-byte magic header of the zip
335 # file.
336 local magic=$(head --bytes=4 "${image}" | hexdump -e '1/1 "%.2x"')
337 if [[ "${magic}" == "504b0304" ]]; then
338 echo "Detected .zip file, extracting Brillo image."
339 extract_image_brillo "$@"
340 return
341 fi
342
343 # Chrome OS images are GPT partitioned disks. We should have the cgpt binary
344 # bundled here and we will use it to extract the partitions, so the GPT
345 # headers must be valid.
346 if cgpt show -q -n "${image}" >/dev/null; then
347 echo "Detected GPT image, extracting Chrome OS image."
348 extract_image_cros "$@"
349 return
350 fi
351
352 die "Couldn't detect the image format of ${image}"
353}
354
Sen Jiang788c2d92016-03-09 12:48:40 -0800355# extract_image_cros <image.bin> <partitions_array> [partitions_order]
Alex Deymo89ff9e32015-09-15 19:29:01 -0700356#
Alex Deymo48b502a2015-09-17 19:00:18 -0700357# Extract Chromium OS recovery images into new temporary files.
Alex Deymo89ff9e32015-09-15 19:29:01 -0700358extract_image_cros() {
359 local image="$1"
360 local partitions_array="$2"
Sen Jiang788c2d92016-03-09 12:48:40 -0800361 local partitions_order="${3:-}"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700362
363 local kernel root
364 kernel=$(create_tempfile "kernel.bin.XXXXXX")
365 CLEANUP_FILES+=("${kernel}")
366 root=$(create_tempfile "root.bin.XXXXXX")
367 CLEANUP_FILES+=("${root}")
368
369 cros_generate_update_payload --extract \
370 --image "${image}" \
371 --kern_path "${kernel}" --root_path "${root}" \
372 --work_dir "${FLAGS_work_dir}" --outside_chroot
373
Alex Deymo83f2f702015-10-14 14:49:33 -0700374 # Chrome OS uses major_version 1 payloads for all versions, even if the
375 # updater supports a newer major version.
376 FORCE_MAJOR_VERSION="1"
377
Tudor Brindusdda79e22018-06-28 18:03:21 -0700378 eval ${partitions_array}[kernel]=\""${kernel}"\"
379 eval ${partitions_array}[root]=\""${root}"\"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700380
Sen Jiang788c2d92016-03-09 12:48:40 -0800381 if [[ -n "${partitions_order}" ]]; then
Tudor Brindusdda79e22018-06-28 18:03:21 -0700382 eval "${partitions_order}=( \"root\" \"kernel\" )"
Sen Jiang788c2d92016-03-09 12:48:40 -0800383 fi
384
Alex Deymo89ff9e32015-09-15 19:29:01 -0700385 local part varname
Tudor Brindusdda79e22018-06-28 18:03:21 -0700386 for part in kernel root; do
Alex Deymo89ff9e32015-09-15 19:29:01 -0700387 varname="${partitions_array}[${part}]"
388 printf "md5sum of %s: " "${varname}"
389 md5sum "${!varname}"
390 done
391}
392
Sen Jiang3e5804d2018-09-06 15:53:00 -0700393# extract_partition_brillo <target_files.zip> <partitions_array> <partition>
394# <part_file> <part_map_file>
395#
396# Extract the <partition> from target_files zip file into <part_file> and its
397# map file into <part_map_file>.
398extract_partition_brillo() {
399 local image="$1"
400 local partitions_array="$2"
401 local part="$3"
402 local part_file="$4"
403 local part_map_file="$5"
404
405 # For each partition, we in turn look for its image file under IMAGES/ and
406 # RADIO/ in the given target_files zip file.
407 local path path_in_zip
408 for path in IMAGES RADIO; do
409 if unzip -l "${image}" "${path}/${part}.img" >/dev/null; then
410 path_in_zip="${path}"
411 break
412 fi
413 done
414 [[ -n "${path_in_zip}" ]] || die "Failed to find ${part}.img"
415 unzip -p "${image}" "${path_in_zip}/${part}.img" >"${part_file}"
416
417 # If the partition is stored as an Android sparse image file, we need to
418 # convert them to a raw image for the update.
419 local magic=$(head --bytes=4 "${part_file}" | hexdump -e '1/1 "%.2x"')
420 if [[ "${magic}" == "3aff26ed" ]]; then
421 local temp_sparse=$(create_tempfile "${part}.sparse.XXXXXX")
422 echo "Converting Android sparse image ${part}.img to RAW."
423 mv "${part_file}" "${temp_sparse}"
424 simg2img "${temp_sparse}" "${part_file}"
425 rm -f "${temp_sparse}"
426 fi
427
428 # Extract the .map file (if one is available).
429 unzip -p "${image}" "${path_in_zip}/${part}.map" >"${part_map_file}" \
430 2>/dev/null || true
431
432 # delta_generator only supports images multiple of 4 KiB. For target images
433 # we pad the data with zeros if needed, but for source images we truncate
434 # down the data since the last block of the old image could be padded on
435 # disk with unknown data.
436 local filesize=$(stat -c%s "${part_file}")
437 if [[ $(( filesize % 4096 )) -ne 0 ]]; then
438 if [[ "${partitions_array}" == "SRC_PARTITIONS" ]]; then
439 echo "Rounding DOWN partition ${part}.img to a multiple of 4 KiB."
440 : $(( filesize = filesize & -4096 ))
441 else
442 echo "Rounding UP partition ${part}.img to a multiple of 4 KiB."
443 : $(( filesize = (filesize + 4095) & -4096 ))
444 fi
445 truncate_file "${part_file}" "${filesize}"
446 fi
447
448 echo "Extracted ${partitions_array}[${part}]: ${filesize} bytes"
449}
450
Sen Jiang788c2d92016-03-09 12:48:40 -0800451# extract_image_brillo <target_files.zip> <partitions_array> [partitions_order]
Alex Deymo48b502a2015-09-17 19:00:18 -0700452#
453# Extract the A/B updated partitions from a Brillo target_files zip file into
454# new temporary files.
455extract_image_brillo() {
456 local image="$1"
457 local partitions_array="$2"
Sen Jiang788c2d92016-03-09 12:48:40 -0800458 local partitions_order="${3:-}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700459
Alex Deymo48b502a2015-09-17 19:00:18 -0700460 local partitions=( "boot" "system" )
Alex Deymo168b5352015-11-04 13:51:52 -0800461 local ab_partitions_list
462 ab_partitions_list=$(create_tempfile "ab_partitions_list.XXXXXX")
463 CLEANUP_FILES+=("${ab_partitions_list}")
464 if unzip -p "${image}" "META/ab_partitions.txt" >"${ab_partitions_list}"; then
465 if grep -v -E '^[a-zA-Z0-9_-]*$' "${ab_partitions_list}" >&2; then
466 die "Invalid partition names found in the partition list."
467 fi
Sen Jiang34c711a2017-10-25 17:25:21 -0700468 # Get partition list without duplicates.
469 partitions=($(awk '!seen[$0]++' "${ab_partitions_list}"))
Alex Deymo168b5352015-11-04 13:51:52 -0800470 if [[ ${#partitions[@]} -eq 0 ]]; then
471 die "The list of partitions is empty. Can't generate a payload."
472 fi
473 else
474 warn "No ab_partitions.txt found. Using default."
475 fi
Sen Jiang3e5804d2018-09-06 15:53:00 -0700476 echo "List of A/B partitions for ${partitions_array}: ${partitions[@]}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700477
Sen Jiang788c2d92016-03-09 12:48:40 -0800478 if [[ -n "${partitions_order}" ]]; then
479 eval "${partitions_order}=(${partitions[@]})"
480 fi
481
Alex Deymo83f2f702015-10-14 14:49:33 -0700482 # All Brillo updaters support major version 2.
483 FORCE_MAJOR_VERSION="2"
484
Alex Deymo48b502a2015-09-17 19:00:18 -0700485 if [[ "${partitions_array}" == "SRC_PARTITIONS" ]]; then
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800486 # Source image
487 local ue_config=$(create_tempfile "ue_config.XXXXXX")
Alex Deymoc97df432015-09-25 17:23:52 -0700488 CLEANUP_FILES+=("${ue_config}")
489 if ! unzip -p "${image}" "META/update_engine_config.txt" \
490 >"${ue_config}"; then
491 warn "No update_engine_config.txt found. Assuming pre-release image, \
492using payload minor version 2"
493 fi
Alex Deymo83f2f702015-10-14 14:49:33 -0700494 # For delta payloads, we use the major and minor version supported by the
495 # old updater.
Alex Deymoc97df432015-09-25 17:23:52 -0700496 FORCE_MINOR_VERSION=$(read_option_uint "${ue_config}" \
497 "PAYLOAD_MINOR_VERSION" 2)
Alex Deymo83f2f702015-10-14 14:49:33 -0700498 FORCE_MAJOR_VERSION=$(read_option_uint "${ue_config}" \
499 "PAYLOAD_MAJOR_VERSION" 2)
Alex Deymo61e1fa82016-01-19 15:16:34 -0800500
501 # Brillo support for deltas started with minor version 3.
502 if [[ "${FORCE_MINOR_VERSION}" -le 2 ]]; then
503 warn "No delta support from minor version ${FORCE_MINOR_VERSION}. \
504Disabling deltas for this source version."
505 exit ${EX_UNSUPPORTED_DELTA}
506 fi
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800507 else
508 # Target image
509 local postinstall_config=$(create_tempfile "postinstall_config.XXXXXX")
510 CLEANUP_FILES+=("${postinstall_config}")
511 if unzip -p "${image}" "META/postinstall_config.txt" \
512 >"${postinstall_config}"; then
513 POSTINSTALL_CONFIG_FILE="${postinstall_config}"
514 fi
Alex Deymo48b502a2015-09-17 19:00:18 -0700515 fi
516
Sen Jiang3e5804d2018-09-06 15:53:00 -0700517 local part
Alex Deymo48b502a2015-09-17 19:00:18 -0700518 for part in "${partitions[@]}"; do
Sen Jiang3e5804d2018-09-06 15:53:00 -0700519 local part_file=$(create_tempfile "${part}.img.XXXXXX")
520 local part_map_file=$(create_tempfile "${part}.map.XXXXXX")
521 CLEANUP_FILES+=("${part_file}" "${part_map_file}")
522 # Extract partitions in background.
523 extract_partition_brillo "${image}" "${partitions_array}" "${part}" \
524 "${part_file}" "${part_map_file}" &
Alex Deymo48b502a2015-09-17 19:00:18 -0700525 eval "${partitions_array}[\"${part}\"]=\"${part_file}\""
Alex Deymo20bdc702016-12-07 21:07:11 -0800526 eval "${partitions_array}_MAP[\"${part}\"]=\"${part_map_file}\""
Sen Jiang3e5804d2018-09-06 15:53:00 -0700527 done
528}
529
530# cleanup_partition_array <partitions_array>
531#
532# Remove all empty files in <partitions_array>.
533cleanup_partition_array() {
534 local partitions_array="$1"
535 # Have to use eval to iterate over associative array keys with variable array
536 # names, we should change it to use nameref once bash 4.3 is available
537 # everywhere.
538 for part in $(eval "echo \${!${partitions_array}[@]}"); do
539 local path="${partitions_array}[$part]"
540 if [[ ! -s "${!path}" ]]; then
541 eval "unset ${partitions_array}[${part}]"
542 fi
Alex Deymo48b502a2015-09-17 19:00:18 -0700543 done
544}
545
Tudor Brindusb432db82018-06-29 13:13:27 -0700546extract_payload_images() {
547 local payload_type=$1
548 echo "Extracting images for ${payload_type} update."
549
550 if [[ "${payload_type}" == "delta" ]]; then
551 extract_image "${FLAGS_source_image}" SRC_PARTITIONS
552 fi
553 extract_image "${FLAGS_target_image}" DST_PARTITIONS PARTITIONS_ORDER
Sen Jiang3e5804d2018-09-06 15:53:00 -0700554 # Wait for all subprocesses.
555 wait
556 cleanup_partition_array SRC_PARTITIONS
557 cleanup_partition_array SRC_PARTITIONS_MAP
558 cleanup_partition_array DST_PARTITIONS
559 cleanup_partition_array DST_PARTITIONS_MAP
Tudor Brindusb432db82018-06-29 13:13:27 -0700560}
561
562get_payload_type() {
563 if [[ -z "${FLAGS_source_image}" ]]; then
564 echo "full"
565 else
566 echo "delta"
567 fi
568}
569
Jason Kusumabe998f42015-09-03 15:53:13 -0700570validate_generate() {
571 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700572 die "You must specify an output filename with --payload FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700573
574 [[ -n "${FLAGS_target_image}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700575 die "You must specify a target image with --target_image FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700576}
577
578cmd_generate() {
Sen Jiang3e5804d2018-09-06 15:53:00 -0700579 local payload_type=$(get_payload_type)
580 extract_payload_images ${payload_type}
Jason Kusumabe998f42015-09-03 15:53:13 -0700581
Alex Deymo48b502a2015-09-17 19:00:18 -0700582 echo "Generating ${payload_type} update."
Alex Deymo168b5352015-11-04 13:51:52 -0800583 # Common payload args:
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700584 GENERATOR_ARGS=( --out_file="${FLAGS_payload}" )
Alex Deymo168b5352015-11-04 13:51:52 -0800585
586 local part old_partitions="" new_partitions="" partition_names=""
Alex Deymo20bdc702016-12-07 21:07:11 -0800587 local old_mapfiles="" new_mapfiles=""
Sen Jiang788c2d92016-03-09 12:48:40 -0800588 for part in "${PARTITIONS_ORDER[@]}"; do
Alex Deymo168b5352015-11-04 13:51:52 -0800589 if [[ -n "${partition_names}" ]]; then
590 partition_names+=":"
591 new_partitions+=":"
592 old_partitions+=":"
Alex Deymo20bdc702016-12-07 21:07:11 -0800593 new_mapfiles+=":"
594 old_mapfiles+=":"
Alex Deymo168b5352015-11-04 13:51:52 -0800595 fi
596 partition_names+="${part}"
597 new_partitions+="${DST_PARTITIONS[${part}]}"
598 old_partitions+="${SRC_PARTITIONS[${part}]:-}"
Alex Deymo20bdc702016-12-07 21:07:11 -0800599 new_mapfiles+="${DST_PARTITIONS_MAP[${part}]:-}"
600 old_mapfiles+="${SRC_PARTITIONS_MAP[${part}]:-}"
Alex Deymo168b5352015-11-04 13:51:52 -0800601 done
602
603 # Target image args:
604 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700605 --partition_names="${partition_names}"
606 --new_partitions="${new_partitions}"
607 --new_mapfiles="${new_mapfiles}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700608 )
609
Alex Deymo89ff9e32015-09-15 19:29:01 -0700610 if [[ "${payload_type}" == "delta" ]]; then
Alex Deymo168b5352015-11-04 13:51:52 -0800611 # Source image args:
Jason Kusumabe998f42015-09-03 15:53:13 -0700612 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700613 --old_partitions="${old_partitions}"
614 --old_mapfiles="${old_mapfiles}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700615 )
Alex Deymo48b502a2015-09-17 19:00:18 -0700616 if [[ -n "${FORCE_MINOR_VERSION}" ]]; then
617 GENERATOR_ARGS+=( --minor_version="${FORCE_MINOR_VERSION}" )
618 fi
619 fi
620
621 if [[ -n "${FORCE_MAJOR_VERSION}" ]]; then
622 GENERATOR_ARGS+=( --major_version="${FORCE_MAJOR_VERSION}" )
Jason Kusumabe998f42015-09-03 15:53:13 -0700623 fi
624
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700625 if [[ -n "${FLAGS_metadata_size_file}" ]]; then
626 GENERATOR_ARGS+=( --out_metadata_size_file="${FLAGS_metadata_size_file}" )
627 fi
628
Sen Jiang8e768e92017-06-28 17:13:19 -0700629 if [[ -n "${FLAGS_max_timestamp}" ]]; then
630 GENERATOR_ARGS+=( --max_timestamp="${FLAGS_max_timestamp}" )
631 fi
632
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800633 if [[ -n "${POSTINSTALL_CONFIG_FILE}" ]]; then
634 GENERATOR_ARGS+=(
635 --new_postinstall_config_file="${POSTINSTALL_CONFIG_FILE}"
636 )
637 fi
638
Jason Kusumabe998f42015-09-03 15:53:13 -0700639 echo "Running delta_generator with args: ${GENERATOR_ARGS[@]}"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700640 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700641
Alex Deymo89ff9e32015-09-15 19:29:01 -0700642 echo "Done generating ${payload_type} update."
Jason Kusumabe998f42015-09-03 15:53:13 -0700643}
644
645validate_hash() {
646 [[ -n "${FLAGS_signature_size}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700647 die "You must specify signature size with --signature_size SIZES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700648
649 [[ -n "${FLAGS_unsigned_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700650 die "You must specify the input unsigned payload with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700651--unsigned_payload FILENAME"
652
Jason Kusumabe998f42015-09-03 15:53:13 -0700653 [[ -n "${FLAGS_payload_hash_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700654 die "You must specify --payload_hash_file FILENAME"
Jason Kusumaf514c542015-11-05 18:43:45 -0800655
656 [[ -n "${FLAGS_metadata_hash_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700657 die "You must specify --metadata_hash_file FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700658}
659
660cmd_hash() {
Sen Jiangbf1266f2015-10-26 11:29:24 -0700661 "${GENERATOR}" \
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700662 --in_file="${FLAGS_unsigned_payload}" \
663 --signature_size="${FLAGS_signature_size}" \
664 --out_hash_file="${FLAGS_payload_hash_file}" \
665 --out_metadata_hash_file="${FLAGS_metadata_hash_file}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700666
Jason Kusumabe998f42015-09-03 15:53:13 -0700667 echo "Done generating hash."
668}
669
670validate_sign() {
671 [[ -n "${FLAGS_signature_size}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700672 die "You must specify signature size with --signature_size SIZES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700673
674 [[ -n "${FLAGS_unsigned_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700675 die "You must specify the input unsigned payload with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700676--unsigned_payload FILENAME"
677
678 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700679 die "You must specify the output signed payload with --payload FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700680
681 [[ -n "${FLAGS_payload_signature_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700682 die "You must specify the payload signature file with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700683--payload_signature_file SIGNATURES"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700684
685 [[ -n "${FLAGS_metadata_signature_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700686 die "You must specify the metadata signature file with \
Alex Deymo89ff9e32015-09-15 19:29:01 -0700687--metadata_signature_file SIGNATURES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700688}
689
690cmd_sign() {
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700691 GENERATOR_ARGS=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700692 --in_file="${FLAGS_unsigned_payload}"
693 --signature_size="${FLAGS_signature_size}"
694 --payload_signature_file="${FLAGS_payload_signature_file}"
695 --metadata_signature_file="${FLAGS_metadata_signature_file}"
696 --out_file="${FLAGS_payload}"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700697 )
698
699 if [[ -n "${FLAGS_metadata_size_file}" ]]; then
700 GENERATOR_ARGS+=( --out_metadata_size_file="${FLAGS_metadata_size_file}" )
701 fi
702
703 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700704 echo "Done signing payload."
705}
706
Alex Deymo98e691c2016-02-04 21:05:45 -0800707validate_properties() {
708 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700709 die "You must specify the payload file with --payload FILENAME"
Alex Deymo98e691c2016-02-04 21:05:45 -0800710
711 [[ -n "${FLAGS_properties_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700712 die "You must specify a non empty --properties_file FILENAME"
Alex Deymo98e691c2016-02-04 21:05:45 -0800713}
714
715cmd_properties() {
716 "${GENERATOR}" \
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700717 --in_file="${FLAGS_payload}" \
718 --properties_file="${FLAGS_properties_file}"
Alex Deymo98e691c2016-02-04 21:05:45 -0800719}
720
Tudor Brindusb432db82018-06-29 13:13:27 -0700721validate_verify_and_check() {
Amin Hassani13520932017-07-26 11:26:05 -0700722 [[ -n "${FLAGS_payload}" ]] ||
723 die "Error: you must specify an input filename with --payload FILENAME"
724
725 [[ -n "${FLAGS_target_image}" ]] ||
726 die "Error: you must specify a target image with --target_image FILENAME"
727}
728
729cmd_verify() {
Tudor Brindusb432db82018-06-29 13:13:27 -0700730 local payload_type=$(get_payload_type)
731 extract_payload_images ${payload_type}
Amin Hassani13520932017-07-26 11:26:05 -0700732
733 declare -A TMP_PARTITIONS
734 for part in "${PARTITIONS_ORDER[@]}"; do
735 local tmp_part=$(create_tempfile "tmp_part.bin.XXXXXX")
736 echo "Creating temporary target partition ${tmp_part} for ${part}"
737 CLEANUP_FILES+=("${tmp_part}")
738 TMP_PARTITIONS[${part}]=${tmp_part}
739 local FILESIZE=$(stat -c%s "${DST_PARTITIONS[${part}]}")
740 echo "Truncating ${TMP_PARTITIONS[${part}]} to ${FILESIZE}"
741 truncate_file "${TMP_PARTITIONS[${part}]}" "${FILESIZE}"
742 done
743
744 echo "Verifying ${payload_type} update."
745 # Common payload args:
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700746 GENERATOR_ARGS=( --in_file="${FLAGS_payload}" )
Amin Hassani13520932017-07-26 11:26:05 -0700747
748 local part old_partitions="" new_partitions="" partition_names=""
749 for part in "${PARTITIONS_ORDER[@]}"; do
750 if [[ -n "${partition_names}" ]]; then
751 partition_names+=":"
752 new_partitions+=":"
753 old_partitions+=":"
754 fi
755 partition_names+="${part}"
756 new_partitions+="${TMP_PARTITIONS[${part}]}"
757 old_partitions+="${SRC_PARTITIONS[${part}]:-}"
758 done
759
760 # Target image args:
761 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700762 --partition_names="${partition_names}"
763 --new_partitions="${new_partitions}"
Amin Hassani13520932017-07-26 11:26:05 -0700764 )
765
766 if [[ "${payload_type}" == "delta" ]]; then
767 # Source image args:
768 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700769 --old_partitions="${old_partitions}"
Amin Hassani13520932017-07-26 11:26:05 -0700770 )
771 fi
772
Amin Hassania566cb62017-08-23 12:36:55 -0700773 if [[ -n "${FORCE_MAJOR_VERSION}" ]]; then
774 GENERATOR_ARGS+=( --major_version="${FORCE_MAJOR_VERSION}" )
775 fi
776
Amin Hassani13520932017-07-26 11:26:05 -0700777 echo "Running delta_generator to verify ${payload_type} payload with args: \
778${GENERATOR_ARGS[@]}"
Sen Jiang6feb15c2018-08-31 15:45:17 -0700779 "${GENERATOR}" "${GENERATOR_ARGS[@]}" || true
Amin Hassani13520932017-07-26 11:26:05 -0700780
Sen Jiang6feb15c2018-08-31 15:45:17 -0700781 echo "Done applying ${payload_type} update."
782 echo "Checking the newly generated partitions against the target partitions"
783 local need_pause=false
784 for part in "${PARTITIONS_ORDER[@]}"; do
785 local not_str=""
786 if ! cmp "${TMP_PARTITIONS[${part}]}" "${DST_PARTITIONS[${part}]}"; then
787 not_str="in"
788 need_pause=true
789 fi
790 echo "The new partition (${part}) is ${not_str}valid."
791 done
792 # All images will be cleaned up when script exits, pause here to give a chance
793 # to inspect the images.
794 if [[ "$need_pause" == true ]]; then
795 read -n1 -r -s -p "Paused to investigate invalid partitions, \
796press any key to exit."
Amin Hassani13520932017-07-26 11:26:05 -0700797 fi
798}
799
Tudor Brindusb432db82018-06-29 13:13:27 -0700800cmd_check() {
801 local payload_type=$(get_payload_type)
802 extract_payload_images ${payload_type}
803
804 local part dst_partitions="" src_partitions=""
805 for part in "${PARTITIONS_ORDER[@]}"; do
806 if [[ -n "${dst_partitions}" ]]; then
807 dst_partitions+=" "
808 src_partitions+=" "
809 fi
810 dst_partitions+="${DST_PARTITIONS[${part}]}"
811 src_partitions+="${SRC_PARTITIONS[${part}]:-}"
812 done
813
814 # Common payload args:
815 PAYCHECK_ARGS=( "${FLAGS_payload}" --type ${payload_type} \
816 --part_names ${PARTITIONS_ORDER[@]} \
817 --dst_part_paths ${dst_partitions} )
818
819 if [[ ! -z "${SRC_PARTITIONS[@]}" ]]; then
820 PAYCHECK_ARGS+=( --src_part_paths ${src_partitions} )
821 fi
822
823 echo "Checking ${payload_type} update."
824 check_update_payload ${PAYCHECK_ARGS[@]} --check
825}
826
Jason Kusumabe998f42015-09-03 15:53:13 -0700827# Sanity check that the real generator exists:
Sen Jiang13519752016-08-02 16:10:52 -0700828GENERATOR="$(which delta_generator || true)"
Jason Kusumabe998f42015-09-03 15:53:13 -0700829[[ -x "${GENERATOR}" ]] || die "can't find delta_generator"
830
831case "$COMMAND" in
832 generate) validate_generate
833 cmd_generate
834 ;;
835 hash) validate_hash
836 cmd_hash
837 ;;
838 sign) validate_sign
839 cmd_sign
840 ;;
Alex Deymo98e691c2016-02-04 21:05:45 -0800841 properties) validate_properties
842 cmd_properties
843 ;;
Tudor Brindusb432db82018-06-29 13:13:27 -0700844 verify) validate_verify_and_check
Amin Hassani13520932017-07-26 11:26:05 -0700845 cmd_verify
846 ;;
Tudor Brindusb432db82018-06-29 13:13:27 -0700847 check) validate_verify_and_check
848 cmd_check
849 ;;
Jason Kusumabe998f42015-09-03 15:53:13 -0700850esac